using System;
using System.Collections;

namespace Solitare
{
	/// <summary>
	/// Summary description for CardCollection.
	/// </summary>
	public class CardCollection {

		private ArrayList _cards;

		public CardCollection() {
			_cards = new ArrayList();
		}

		public int Count {
			get { return _cards.Count; }
		}
		
		public PlayingCard this[int CardNumber] {
			get {
				return (PlayingCard)_cards[CardNumber];
			}
		}

		public void Push(PlayingCard Card) {
			_cards.Add(Card);
		}

		public void PushBottom(PlayingCard Card) {
			_cards.Insert(0, Card);
		}
		
		public PlayingCard Pop() {
			PlayingCard c = this.Peek();
			_cards.Remove(c);
			return c;
		}

		public PlayingCard Peek() {
			PlayingCard c = (PlayingCard)_cards[_cards.Count - 1];
			return c;
		}

      public bool Remove(PlayingCard Card) {
         _cards.Remove(Card);
         return !_cards.Contains(Card);
      }
	}
}
