using System;
using System.Collections;
using System.Diagnostics;
using System.IO;
using System.Runtime.Serialization.Formatters.Soap;

namespace Solitare {
   [Serializable]
   public class Statistics {
      private int _gamesPlayed;
      public int GamesPlayed {
         get { return _gamesPlayed; }
         set { _gamesPlayed = value; }
      }
      
      private int _gamesWon;
      public int GamesWon {
         get { return _gamesWon; }
         set { _gamesWon = value; }
      }

      private String _gameName;
      public String GameName {
         get { return _gameName; }
         set { _gameName = value; }
      }

      private int _lastSeedUsed;
      public int LastSeedUsed {
         get { return _lastSeedUsed; }
         set { _lastSeedUsed = value; }
      }

      public Statistics() {
         _gameName = "";
         _gamesPlayed = 0;
         _gamesWon = 0;
         _lastSeedUsed = -1;
      }

      private static bool _autoplayStats;
      public static bool AutoplayStats {
         get { return _autoplayStats; }
         set { _autoplayStats = value; 
            if (_autoplayStats) {
               fileName = "c:\\temp\\autoplay.txt";
            } else {
               fileName = "c:\\temp\\solitare.txt";
            }
         }
      }

      private static String fileName = "c:\\temp\\solitare.txt";

      public static ArrayList ReadStatisticsFile() {
         try {
            FileStream fs = new FileStream(fileName, FileMode.Open);
            SoapFormatter sf = new SoapFormatter();
         

            ArrayList al = (ArrayList)sf.Deserialize(fs);

            fs.Close();
            return al;
         } catch (Exception e) {
            Trace.WriteLine("STATISTICS EXCPTION\n" + e);
         }

         return new ArrayList();
      }

      public static void WriteStatisticsFile(ArrayList Info) {
         SoapFormatter sf = new SoapFormatter();
         
         FileStream fs = new FileStream(fileName, FileMode.Create);

         sf.Serialize(fs, Info);

         fs.Close();
      }

      public static Statistics LoadGameStatistics(String GameName) {
         ArrayList al = ReadStatisticsFile();
         foreach (Statistics s in al) {
            if (s.GameName == GameName) {
               return s;
            }
         }
         Statistics s1 = new Statistics();
         s1.GameName = GameName;

         return s1;
      }
      
      public static void SaveGameStatistics(Statistics CurrentStats) {
         ArrayList al = ReadStatisticsFile();
         Trace.WriteLine("Statistics:" + al.Count);         
         bool found = false;
         for (int i = 0; i < al.Count; i++) {
            Statistics s = (Statistics)al[i];
            if (s.GameName == CurrentStats.GameName) {
               al.Remove(s);
               al.Add(CurrentStats);
               found = true;
               break;
            }
         }
         if (found == false) {
            al.Add(CurrentStats);
         }

         WriteStatisticsFile(al);
      }
   }
}